<script lang="ts">
import { defineComponent } from 'vue';

export const sizeConfig = ['m', 'l', 'xl', 'xxl'];

export default defineComponent({
  name: 'JListItem',
  props: {
    tag: {
      type: String,
      default: 'div',
    },
    active: {
      type: Boolean,
      default: false,
    },
    disabled: {
      type: Boolean,
      default: false,
    },
    hoverEffect: {
      type: Boolean,
      default: true,
    },
    hoverOnIcons: {
      type: Boolean,
      default: true,
    },
    size: {
      type: String,
      default: 'l',
      validator(value: string): boolean {
        return sizeConfig.includes(value);
      },
    },
  },
});
</script>

<template>
  <component
    :is="tag"
    v-ripple="{ disabled: disabled || hoverEffect === false }"
    v-bind="$attrs"
    :tabindex="hoverEffect ? 0 : -1"
    class="j-list-item"
    :data-icons="hoverOnIcons"
    :class="[{ active, disabled, 'hover-effect': hoverEffect }, size]"
  >
    <slot />
  </component>
</template>

<style scoped lang="scss">
@use '../../icon/JIcon/mixins.scss' as iconMixins;

.j-list-item {
  display: flex;
  align-items: center;
  flex: 1 1 100%;
  position: relative;
  padding: 0 16px;
  letter-spacing: normal;
  text-decoration: none;

  &:focus-visible {
    outline: none;
    box-shadow: var(--j-focus-shadow);
  }

  &.disabled {
    cursor: not-allowed;
  }

  &.hover-effect:hover {
    cursor: pointer;
    background-color: var(--j-primary-hover-color);
  }

  // TODO: redo to scss variable
  &.m {
    min-height: 40px;
  }

  &.l {
    min-height: 48px;
  }

  &.xl {
    min-height: 56px;
  }

  &.xxl {
    min-height: 65px;
  }

  &[data-icons='true']:focus-visible,
  &[data-icons='true']:hover,
  &.active[data-icons='true'] {
    @include iconMixins.primary-color-on-hover;
    @include iconMixins.toggle-use-tag-by-hover-attr;
  }
}
</style>
